#!/bin/bash

##############  v2ray安装脚本  #################
echo -e ''
echo -e "\033[32m====== v2ay for OPNsense安装脚本 ======\033[0m"
echo -e ''

# 设定目录变量
root=/usr/local

# 创建目录
mkdir -p $root/share/v2ray/
mkdir -p $root/etc/v2ray/

# 移动文件
cp v2ctl v2ray $root/bin/
cp geoip.dat geosite.dat geoip-only-cn-private.dat $root/share/v2ray
cp config.json $root/etc/v2ray/
cp rc $root/etc/rc.d/v2ray
echo -e '\n文件复制完成！'
echo -e ''

# 向/etc/rc.conf添加以下内容
sysrc v2ray_enable="YES"
echo -e '启动参数添加完成!'

# 赋予程序权限
chmod +x /usr/local/bin/v2ray
chmod +x /usr/local/bin/v2ctl
chmod +x /usr/local/etc/rc.d/v2ray
echo -e '执行权限添加完成！'

# 添加组和用户
pw addgroup -n v2ray
pw adduser v2ray -g v2ray -d /nonexistent -s /usr/sbin/nologin -c "V2ray Daemon"
echo -e 'v2ray用户和组添加完成！'

#  添加开机启动脚本（OPNsense适用）
cat>/usr/local/etc/rc.syshook.d/start/30-v2ray<<EOF
service v2ray start
EOF
chmod +x /usr/local/etc/rc.syshook.d/start/30-v2ray
echo -e '开机脚本添加完成！'
echo -e ''

#  测试配置文件
echo -e '测试配置，请根据出错提示修改配置文件:'
/usr/local/bin/v2ray test -c /usr/local/etc/v2ray/config.json
echo -e ''
echo -e "\033[32mv2ray安装完成！\033[0m"

#  显示命令说明
echo -e '\n使用说明：'
echo -e "\033[32m启动v2ray: service v2ray start\033[0m"
echo -e "\033[32m停止v2ray: service v2ray stop\033[0m"
echo -e "\033[32m重启v2ray: service v2ray restart\033[0m"

#  显示命令说明
echo -e '\n手动调试：'
echo -e "\033[32m/usr/local/bin/v2ray run -c /usr/local/etc/v2ray/config.json\033[0m"